#######
# archivesToLinks.py
# description : get all the internal/external hyperlinks from a list of archived url
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

# python3 archivesToLinks.py output/archives-firsttuesday.com-1996-2010.csv

import sys
import csv
from bs4 import BeautifulSoup
import urllib.request

path = ""

try :
    path = sys.argv[1]
except :
    print ("! args error\n")
    sys.exit(0)

def getArchive(url) :
    try :
        req = urllib.request.Request(url)
        with urllib.request.urlopen(req) as res:
            return res.read()
    except Exception as e :
        print(str(e))
        return None           

with open(path, newline='\n') as file :
    
    rawData  = csv.reader(file, delimiter=';')
    next(rawData)
    fileName = path.replace(".csv","").split('-')
    
    output = open("output/rawLinks-" + fileName[2] + "-" + fileName[3] + ".csv", "w")
    header = "timestamp;date;url;digest;link\n"
    output.write(header) 

    i = 0
    
    for row in rawData :

        if (i % 20 == 0) :
            print(str(i) + " archives analyzed")

        if i > 0 :

            id = row[0] + 'id_'
            url = row[2].replace(':80/','/')
            wayback = "https://web.archive.org/web/" + id + "/" + url
            archive = getArchive(wayback)

            if archive is None or archive == "" :
                continue
            else :
                soup = BeautifulSoup(archive, 'html.parser')
                for link in soup.find_all('a'):
                    
                    href = link.get('href')

                    if href is not None :
                        output.write(row[0] + ";" + row[1] + ";" + url + ";" + row[3] + ";" + href + "\n")

        i += 1
        

               