#######
# fragmentsToPhylo.py
# description : transform a json Web fragments file into a phylomemy's corpus -- see Gargantext formats (https://iscpif.fr/gargantext/import-formats_en/)
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

import sys
import csv
import json

try :
    archives_path = sys.argv[1]
except :
    print ("! args error\n")
    print ("try : python3 fragmentsToPhylo.py output/assembled_archive.json\n")
    sys.exit(0)
    

fragments = []

output = open("output/corpus-phylo.csv", "w")
header = '"publication_day"\t"publication_month"\t"publication_year"\t"authors"\t"title"\t"source"\t"abstract"\t"weight"\n'
output.write(header)  

with open(archives_path, 'r') as file :
        archives = json.load(file)
        fragments = archives["fragments"]

for frag in fragments :

    # to Gargantext v3
    # publication_day = "01"
    # publication_month = "1"
    # publication_year = "1"
    # authors = "firsttuesday"
    # title = frag["title"]
    # abstract = frag["content"]
    # source = ""
    # weight = "1"

    # to Phylomemy
    publication_day = "01"
    publication_month = "1"
    publication_year = str(frag["time_unit"])
    authors = "firsttuesday"
    title = frag["title"]
    abstract = frag["content"]
    source = frag["url"]
    weight = "1"


    output.write(publication_day + '\t' + publication_month + '\t' + publication_year + '\t' + authors + '\t' + title + '\t' + source + '\t' + abstract + '\t' + weight + '\n')
    