#######
# graphToCliques.py
# description : find the cliques within a continuity graph
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

# python3 graphToCliques.py output/continuity-graph-1996-2010.csv

import sys
import csv
import json
import networkx as nx

pathEdges  = ""

try :
    pathEdges = sys.argv[1]
except :
    print ("! args error\n")
    sys.exit(0)

inf = pathEdges.split('-')[2]
sup = pathEdges.split('-')[3].replace(".csv","")

cliques = {'cliques':[]}

with open(pathEdges, newline='\n') as file :

	# jump the header
	next(file, '')

	graph = nx.read_edgelist(file,nodetype=int,delimiter=';')

	for clq in nx.clique.find_cliques(graph) :

		cliques['cliques'].append(clq)

# export

with open("output/cliques-" + inf + "-" + sup + ".json", 'w') as file :
   
   json.dump(cliques, file, sort_keys=True, indent=4)
