#######
# linksToUnarchived.py
# description : find unarchived pages among internal links
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

# python3 linksToUnarchived.py output/archives-firsttuesday.com-1996-2010.csv output/linksInternals-1996-2010.csv

import sys
import csv

pathArchives = ""
pathLinks = ""

try :
    pathArchives = sys.argv[1]
    pathLinks = sys.argv[2]
except :
    print ("! args error\n")
    sys.exit(0)

archived = set()

# Extract a set of archived urls as reference

with open(pathArchives, newline='\n') as file :

    rawArchives = csv.reader(file, delimiter=';')
    next(rawArchives)

    for row in rawArchives :

        url = row[2].split("/")[3:]

        archived.add(("/" + "/".join(url)).lower())

# Shape the unarchived links

inf = pathArchives.split('-')[2]
sup = pathArchives.split('-')[3].replace(".csv","")
header = "timestamp;date;url;digest\n"
unarchived = open("output/unarchived-" + inf + "-" + sup + ".csv", "w")
unarchived.write(header)  

with open(pathLinks, newline='\n') as file :

    rawLinks = csv.reader(file, delimiter=';')
    next(rawLinks)

    for row in rawLinks :

        link = row[4]

        # clean the link

        if ("firsttuesday.com" in link) :
            link = ("/" + "/".join(link.split("/")[3:]))

        if (link == "/" or link == "//" or link.endswith("/")) :
            continue

        if (link.startswith("../")) :
            link = link.replace("../","/")

        if (link.startswith("./")) :
            link = link.replace("./","/")

        if (not link.startswith("/")) :
            link = "/" + link

        if (link.endswith(".htm")) :
            link = link.replace(".htm",".html")

        # match the link with an archived url

        if (link not in archived) :

            unarchived.write(row[0] + ";" + row[1] + ";" + link + ";null\n")

print("End of script")