#######
# sortLinks.py
# description : distribute archived links among internals, externals, constellations and emails
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

# python3 sortLinks.py output/rawLinks-1996-2010.csv

import sys
import csv

path = ""

try :
    path = sys.argv[1]
except :
    print ("! args error\n")
    sys.exit(0)

inf = path.split('-')[1]
sup = path.split('-')[2].replace(".csv","")
header = "timestamp;date;url;digest;link\n"

emails = []
emailsCsv = open("output/linksEmails-" + inf + "-" + sup + ".csv", "w")
emailsCsv.write(header)

externals = []
externalsCsv = open("output/linksExternals-" + inf + "-" + sup + ".csv", "w")
externalsCsv.write(header)

constellations = []
constellationsCsv = open("output/linksConstellations-" + inf + "-" + sup + ".csv", "w")
constellationsCsv.write(header)

internals = []
internalsCsv = open("output/linksInternals-" + inf + "-" + sup + ".csv", "w")
internalsCsv.write(header)


with open(path, newline='\n') as file :
    
    rawLinks = csv.reader(file, delimiter=';')
    next(rawLinks)

    for row in rawLinks :

        if len(row) == 5 :

            link = row[4].lower()

            if ("javascript" in link) :
                continue

            if ("mailto" in link) or ("@" in link) :
                
                emails.append(row)
            
            elif ("http:" in link) and ("firsttuesday" not in link) :

                externals.append(row)

            elif ("http:" in link) and ("firsttuesday" in link) and ("firsttuesday.com" not in link) :

                constellations.append(row)

            else :

                internals.append(row)

    # process the emails
    
    for row in emails :

        adrs = row[4].replace("mailto:","").strip().replace(">","").split("?", 1)[0]

        if ("http:" in adrs) or ("" == adrs) or (adrs is None) :
            continue

        emailsCsv.write(row[0] + ";" + row[1] + ";" + row[2] + ";" + row[3] + ";" + adrs + "\n")

    # process the externals

    for row in externals :

        if (row[4].lower() == "http://") :
            continue

        externalsCsv.write(row[0] + ";" + row[1] + ";" + row[2] + ";" + row[3] + ";" + row[4].strip() + "\n")

    # process the constellations

    for row in constellations :

        constellationsCsv.write(row[0] + ";" + row[1] + ";" + row[2] + ";" + row[3] + ";" + row[4].strip() + "\n")

    # process internals 

    for row in internals :

        if (row[4].lower().startswith('#')) :
            continue

        internalsCsv.write(row[0] + ";" + row[1] + ";" + row[2] + ";" + row[3] + ";" + row[4].strip() + "\n")


print("End of script")







